## Local stack

[Gitlab Repo](https://forge.grandlyon.com/web-et-numerique/llle_project/cozy-stack)

### Why are we cloning the official repo ?

Because of some political choice Cozy Cloud are not maintaining there official [docker image](https://hub.docker.com/r/cozy/cozy-app-dev) properly. That's why we have a mirroring version of there official repository with some custom docker configuration improving :
	
* CouchDb version. Officially Cozy Cloud use CouchDb 3.2.2, but in there official image it's not the case yet.

### What change should be done by cozy in order to upgrade there image ?

Cozy should upgrade there CouchDb version inside there image. But unfortunately, the base image `debian:stretch-slim` does not support ERLANG/OTP>=19, and CouchDb need at least a version >=20 for their `3.2.2` version, see [official doc](https://docs.couchdb.org/en/stable/whatsnew/3.2.html#id2).

As a consequence they should upgrade there base image to at least `debian:buster`. But this add a new issue, the official binary of couch-db cannot be build on this version according to some missing libraries.

That's why we took the shortcut of using an official [CouchDb image](https://hub.docker.com/_/couchdb)

### How to build new version of the stack ?

If we want to build a new stack version it's easy ! A manual pipeline has been created. You just need to run the following steps :

* Run the manual pipeline in CI/CD part of gitlab
* Enter the requested parameter `VERSION` and a value (ex: 1.5.7)

![Stack Pipeline](/img/stack-pipeline.png)

The image will be automaticaly build based on the branch and store in the registry.
